<template>
  <div id="categories">
    <v-container fluid>
      <v-row class="d-flex justify-center mt-5">
        <v-card class="mt-8 elevation-8 mx-auto mb-7" style="width: 90%">
          <v-card-title class="d-block text-center pt-6 pb-5 text-h4">
            Categorie di Prodotto
          </v-card-title>
          <v-card-text>
            <v-data-table
                hide-default-footer
                :items="categories"
                :headers="headers"
                item-key="item.id"
            >
              <template v-slot:top>
                <v-toolbar
                    flat
                >
                  <v-btn
                      color="primary"
                      dark
                      rounded
                      class="mb-2"
                      @click="dialog = true"
                  >
                    <v-icon small>far fa-plus-square</v-icon>
                  </v-btn>
                </v-toolbar>
              </template>
              <template v-slot:item.actions="{ item }">
                <v-icon
                    small
                    color="primary"
                    class="mx-2"
                    @click="editCategoryPopup(item)"
                >
                  fas fa-edit
                </v-icon>
                <v-icon
                    small
                    color="primary"
                    class="mx-2"
                    @click="deleteCategories(item)"
                >
                  fas fa-trash
                </v-icon>
              </template>
            </v-data-table>
          </v-card-text>
        </v-card>
      </v-row>
    </v-container>

    <v-dialog
        v-model="dialog"
        width="50%"
        @click:outside="closeDialog"
        @close="closeDialog"
    >
      <v-card class="pt-10">
        <v-card-text>
          <v-text-field
              id="name"
              label="Nome"
              name="name"
              v-model="category.name"
              outlined
              prepend-icon="far fa-store"
              type="text"
          ></v-text-field>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" @click="categoryToEditId !== null ? editCategory() : createCategory()" >
            Salva
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>

</template>

<script>
export default {
  name: "Categories",
  data() {
    return {
      headers: [
        {value: "id", text: "Id"},
        {value: "name", text: "Nome"},
        {text: 'Actions', value: 'actions', sortable: false}
      ],
      categories: [],
      dialog: false,
      category: {
        name: null,
      },
      categoryToEditId: null
    }
  },
  mounted() {
    this.getCategories()
  },
  methods: {
    async getCategories() {
      let response = await this.$http.get('/categories');
      this.categories = response.data;
    },
    async deleteCategories(item) {
      if (window.confirm("Sei sicuro di voler eliminare " + item.name + "?")) {
        await this.$http.delete('/categories/' + item.id)
        await this.getCategories()
      } else
        window.alert('Menomale, poverino!')

    },
    async editCategory() {
      try {
        await this.$http.put('/categories/' + this.categoryToEditId,  this.category)
      } catch (error) {
        window.alert('Errore nella creazione!')
      } finally {
        await this.closeDialog()
      }
    },

    async createCategory() {
      try {
        await this.$http.post('/categories', this.category)
      } catch (error) {
        window.alert('Errore nella creazione della categoria. \n Aprire la console per i dettagli')
        console.log(error)
      } finally {
        await this.closeDialog()
      }
    },

    editCategoryPopup(item) {
      this.category.name = item.name;
      this.categoryToEditId = item.id;
      this.dialog = true;
    },
    async closeDialog() {
      this.resetCategory();
      this.dialog = false;
      await this.getCategories();
    },
    resetCategory() {
      this.category.name = null;
      this.categoryToEditId = null
    }
  }
}

</script>

<style scoped>

</style>
